#version 330
 
layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

in float vParticleScale[];
out float fParticleScale;
out vec2 vTexCoord;

void main() 
{
  gl_Position = ( gl_in[0].gl_Position + vec4( -0.5 * vParticleScale[0], -0.5 * vParticleScale[0], 0.0, 0.0 ) );
  fParticleScale = vParticleScale[0];
  vTexCoord = vec2( 0.0, 0.0 );
  EmitVertex();
  gl_Position = ( gl_in[0].gl_Position + vec4( 0.5 * vParticleScale[0], -0.5 * vParticleScale[0], 0.0, 0.0 ) );
  fParticleScale = vParticleScale[0];
  vTexCoord = vec2( 1.0, 0.0 );
  EmitVertex();
  gl_Position = ( gl_in[0].gl_Position + vec4( -0.5 * vParticleScale[0], 0.5 * vParticleScale[0], 0.0, 0.0 ) );
  fParticleScale = vParticleScale[0];
  vTexCoord = vec2( 0.0, 1.0 );
  EmitVertex();
  gl_Position = ( gl_in[0].gl_Position + vec4( 0.5 * vParticleScale[0], 0.5 * vParticleScale[0], 0.0, 0.0 ) );
  fParticleScale = vParticleScale[0];
  vTexCoord = vec2( 1.0, 1.0 );
  EmitVertex();
  EndPrimitive();
}